#[derive(Debug)]
struct Rectangle {
    width: u32,
    height: u32,
}

// it is rare to see just "self" alone.
// Typically always see "&self"
// This is also very similar to Haskell
impl Rectangle {
    // urhmm actkually these are *methods* and not *functions*
    fn area(&self) -> u32 {
        self.width * self.height
    }

    fn width(&self) -> bool {
        self.width > 0
    }
}

fn main() {
    let rect1 = Rectangle {
        width: 30,
        height: 50,
    };

    println!(
        "The area of the rectangle is {} square pixels.",
        rect1.area()
    );

    if rect1.width() {
        println!("rect has a nonzero width; it is: {}", rect1.width);
    }

    // stopped here:
    // https://rust-book.cs.brown.edu/ch05-03-method-syntax.html#methods-and-ownership
}
